%
%  beam_base_fea_post.m  ver 1.2  December 20, 2012
%
function[trans_acc_frf,trans_vel_frf,trans_disp_frf,trans_rel_disp_frf,...
   fig_num]=beam_base_fea_post(ipin,nodex,acc_frf,freq,fstart,fend,fig_num,iu)
%
%%
%%%% disp('  Constraint rotational dof ');
%%%% disp('  1=none '); 
%%%% disp('  2=left end only ');
%%%% disp('  3=left & right ends  ')
% fix here..
%
if(ipin==2)
     [acc_frf]=add_column(acc_frf,2);
end
if(ipin==3)
     [acc_frf]=add_column(acc_frf,2);
     sz=size(acc_frf);
     [acc_frf]=add_column(acc_frf,sz(2)+1);    
end
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
freq=freq';
omega=2*pi*freq;
%%
%
nfreq=max(size(freq));
%
sz=size(acc_frf);
nnn=sz(2);
%
trans_vel_frf=zeros(nfreq,nnn);
trans_disp_frf=zeros(nfreq,nnn);
trans_rel_disp_frf=zeros(nfreq,nnn);
%
trans_acc_frf=acc_frf;
%
for i=1:nnn
%     
     for j=1:nfreq
         trans_vel_frf(j,i)=acc_frf(j,i)/omega(j);    
        trans_disp_frf(j,i)=acc_frf(j,i)/omega(j)^2;
%
        trans_rel_disp_frf(j,i)=trans_disp_frf(j,i) - 1/omega(j)^2;
%
     end
%     
end
%
         trans_acc_frf=abs( trans_acc_frf  );
         trans_vel_frf=abs( trans_vel_frf  ); 
        trans_disp_frf=abs( trans_disp_frf ); 
    trans_rel_disp_frf=abs( trans_rel_disp_frf );     
%
    if(iu==1)
        G_conv=386.;
    else
        G_conv=9.81;        
    end
         trans_vel_frf=trans_vel_frf*G_conv;
        trans_disp_frf=trans_disp_frf*G_conv;
    trans_rel_disp_frf=trans_rel_disp_frf*G_conv;    
%%
i=1;
while(i==1)
%
    disp(' ');
    sn=input(' Enter response node for plotting ');
%
    plot_dof=2*sn-1;
%
    figure(fig_num);
    fig_num=fig_num+1;
    plot(freq,trans_acc_frf(:,plot_dof));
    grid on;
    xlabel('Frequency (Hz)');
    ylabel('Response Accel/Base Accel (G/G) ');
%
    if(iu==1)
        out1=sprintf(' Accel FRF  Node %d relative to Base, x=%8.4g inch',sn,nodex(sn));
    else
        out1=sprintf(' Accel FRF  Node %d relative to Base, x=%8.4g meters',sn,nodex(sn));       
    end
    title(out1);
%
    set(gca,'MinorGridLineStyle',':','GridLineStyle',':','XScale',...
               'log','YScale','log','XminorTick','on','YminorTick','on');           
%
    [fmin,fmax,ymin,ymax]=find_plot_limits(freq,trans_acc_frf(:,plot_dof));
    axis([fstart,fend,ymin,(ymax*1.01)])
%
    figure(fig_num);
    fig_num=fig_num+1;
    plot(freq,trans_rel_disp_frf(:,plot_dof));
    grid on;
    xlabel('Frequency (Hz)');
%
    if(iu==1)
        ylabel('Response Relative Displacement/Base Accel (in/G) ');
        out1=sprintf(' Rel Disp FRF  Node %d relative to Base, x=%8.4g in',sn,nodex(sn));
    else
        ylabel('Response Relative Displacement/Base Accel (meters/G) ');
        out1=sprintf(' Rel Disp FRF  Node %d relative to Base, x=%8.4g meters',sn,nodex(sn));        
    end    
%    
    title(out1);
%
    set(gca,'MinorGridLineStyle',':','GridLineStyle',':','XScale',...
               'log','YScale','log','XminorTick','on','YminorTick','on');           
%
    [fmin,fmax,ymin,ymax]=find_plot_limits(freq,trans_rel_disp_frf(:,plot_dof));
    axis([fstart,fend,ymin,(ymax*1.01)]);    
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
    af=[freq trans_acc_frf(:,plot_dof) ];
%
    [xmax,ymax]=find_max(af);
    disp(' ');
    out1=sprintf('    Accel FRF:  max = %8.3g G/G at %8.4g Hz  ',xmax,ymax);
    disp(out1);    
%    
    rf=[freq trans_rel_disp_frf(:,plot_dof) ];
%
    [xmax,ymax]=find_max(rf);
%
    if(iu==1)
        out1=sprintf(' Rel Disp FRF:  max = %8.3g in/G at %8.4g Hz  ',xmax,ymax);
    else
        out1=sprintf(' Rel Disp FRF:  max = %8.3g meters/G at %8.4g Hz  ',xmax,ymax);       
    end    
% 
    disp(out1);    
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
    disp(' ');
    disp(' Plot another nodal response?  1=yes 2=no ');
    i=input(' ');
%
end