%
%  beam_data_entry_base.m  ver 1.2  January 14, 2014
%
function[E,I,A,rho,ipin,ne,total_length,xv,dx,dof,ipm,pm,xpm,nodex]=...
                                                   beam_data_entry_base(iu)
%
pm=0.;
xpm=0.;
disp(' ');
icross=input(' Enter the cross-section: \n 1=rectangle  2=solid cylinder  3=other ');
disp(' ');
%%
%%
%
if(iu==1)
    if(icross==1)
			width=input(' Enter the width (inch) ');
			thick=input(' Enter the thickness (inch) ');
			A=width*thick;
			I=(1./12.)*width*(thick^3.);
    end
    if(icross==2)
			diam=input(' Enter the diameter (inch) ');
			A=(pi/4.)*(diam^2.);
			I=(pi/64.)*(diam^4.);
    end
    if(icross ~=1 && icross ~=2)
            disp(' ');
            I = input(' Enter the area moment of inertia (in^4) ');
            %
            disp(' ');
            A = input(' Enter the cross-section area (in^2) ');
    end
%
else
    if(icross==1)
			width=input(' Enter the width (mm) ');
			thick=input(' Enter the thickness (mm) ');
			A=width*thick;
			I=(1./12.)*width*(thick^3.);
    end
    if(icross==2)
			diam=input(' Enter the diameter (mm) ');
			A=(pi/4.)*(diam^2.);
			I=(pi/64.)*(diam^4.);
    end
    if(icross ~=1 && icross ~=2)
            disp(' ');
            I = input(' Enter the area moment of inertia (mm^4) ');
            %
            disp(' ');
            A = input(' Enter the cross-section area (mm^2) ');
    end
% 
    A=A/1000^2;
    I=I/1000^4;
% 
end
%
disp(' ');
disp(' Select material '); 
disp(' 1=aluminum  2=steel  3=G10  4=other '); 
imat = input(' '); 
% 
if(imat==1)      % aluminum 
    if(iu==1)
        E=1.0e+07; 
        rho=0.1;
    else
        E=6.891e+010; 
        rho=2768;        
    end
end  
% 
if(imat==2)      % steel 
    if(iu==1)
        E=3.0e+07; 
        rho=0.285; 
    else
        E=2.067e+011;
        rho=7887;
    end
end
%
if(imat==3)   % G10
    if(iu==1)
       E=2.7e+006;  
       rho=0.065 ;
    else
       E=1.8606e+010; 
       rho=1799.;
    end
end
% 
if(imat~=1 && imat ~=2 && imat ~=3) 
    disp(' ');
    if(iu==1)
        disp(' Enter elastic modulus (lbf/in^2)');
    else
        disp(' Enter elastic modulus (N/m^2)');        
    end
    E=input(' '); 
%
    disp(' '); 
    if(iu==1)
        disp(' Enter mass density (lbm/in^3)');
    else
        disp(' Enter mass density (kg/m^3)');      
    end
    rho=input(' '); 
%    
end 
% 
if(iu==1)
    rho=rho/386.;
end
%
rho=rho*A;
%
disp(' ');
if(iu==1)
    total_length = input(' Enter the length (inch) ');
else
    total_length = input(' Enter the length (meters) ');    
end    
%
%  Recommend at least 16 elements to obtain reasonably accurate effective
%  modal mass values.
%
disp(' ');
ne = input(' Enter the number of elements ');
%
if(ne > 10000) 
    ne=10000;
end
%
disp('  Constrain rotational dof ');
disp('  1=none '); 
disp('  2=left end only ');
disp('  3=left & right ends  ');
%
ipin=input(' ');
%
%
disp(' ');
disp(' Enter point mass? 1=yes  2=no  ');
ipm=input(' ');
if(ipm==1)
   xpm= input(' What is the distance of the point mass from the left boundary ?');
   disp(' ');
   if(iu==1)
        pm= input(' What is the point mass (lbm)?');
        pm=pm/386.;
   else
        pm= input(' What is the point mass (kg)?');       
   end    
end
%
dxx=total_length/ne;
xv(1)=0.;
nodex(1)=0;
for i=2:(ne+2)
    xv(i)=xv(i-1)+dxx;
    if(xv(i)<=total_length)
        nodex(i)=xv(i);
    end   
end
for i=1:(ne+1)
    dx(i)=xv(i+1)-xv(i);
end
%
iflag=0;
if(ipm==1)
    for i=1:(ne+1)
      if( abs(xpm-xv(i))< total_length/1000.)
          xpm=xv(i);
          iflag=1;
          break;
      end
    end
end
if(ipm==1 && iflag==0)
    xv(ne+2)=xpm;
    temp=sort(xv);
    num=max(size(temp));
    num=num-1;
    for i=1:num
        dx(i)=temp(i+1)-temp(i);
    end    
    ne=ne+1;
end
dof=2*ne+2;
%